<template>
  <div class="guest_page">
    <div class="bg-wrapper">
      <Background></Background>
    </div>
    <div class="guest_page_container">
      <div class="logo_container">
        <router-link :to="{name: 'Login'}">
          <img :src="`${$baseUrl}/images/logo-HETA2.png`" alt="HETACHAIN" class="img">
        </router-link>
        <div class="guest_page_form">
          <div class="form-container">
            <div class="guest_page_form_header">
              <div class="title">{{ $t('auth.whitelist.title') }}</div>
              <div class="sub_title">{{ $t('auth.whitelist.sub_title') }}</div>
            </div>
            <div class="guest_page_form_body">
              <div class="input_group">
                <div class="input_group_prepend">
                  <i class="iconmo-email"></i>
                </div>
                <input v-model="whitelist.email"
                       @focus="resetError"
                       @keyup.enter="register"
                       v-validate="'required|max:255'"
                       :placeholder="$t('auth.placeholder.email')"
                       name="email"
                       data-vv-validate-on="none"
                       type="email"
                       class="form_input">
                <span class="invalid-feedback" v-if="errors.has('email')">{{ errors.first('email') }}</span>
              </div>

              <div class="input_group">
                <div class="input_group_prepend">
                  <i class="iconmo-name"></i>
                </div>
                <input data-vv-as="full name"
                       v-model="whitelist.name"
                       @focus="resetError"
                       @keyup.enter="register"
                       v-validate="'required|max:255'"
                       :placeholder="$t('auth.placeholder.full_name')"
                       data-vv-validate-on="none"
                       name="name"
                       type="text"
                       class="form_input">
                <span class="invalid-feedback" v-if="errors.has('name')">{{ errors.first('name') }}</span>
              </div>

              <div class="input_group">
                <div class="input_group_prepend">
                  <i class="iconmo-ETH_1"></i>
                </div>
                <input
                  data-vv-as="ETH address"
                  v-model="whitelist.eth_address"
                  @focus="resetError"
                  @keyup.enter="register"
                  v-validate="'required|max:255|is_eth_address'"
                  :placeholder="$t('auth.placeholder.eth_address')"
                  data-vv-validate-on="none"
                  name="eth_address"
                  type="text"
                  class="form_input">
                <span class="invalid-feedback" v-if="errors.has('eth_address')">{{ errors.first('eth_address') }}</span>
              </div>

              <div class="input_group">
                <div class="input_group_prepend">
                  <i class="iconmo-ETH_1"></i>
                </div>
                <currency-input
                  :precision="18"
                  data-vv-as="ETH amount"
                  v-model="whitelist.eth_amount"
                  @focus="resetError"
                  @keyup.enter="register"
                  v-validate="'required|gt:0'"
                  :placeholder="$t('auth.placeholder.eth_amount')"
                  data-vv-validate-on="none"
                  name="eth_amount"
                  class="form_input">
                </currency-input>
                <span class="invalid-feedback" v-if="errors.has('eth_amount')">{{ errors.first('eth_amount') }}</span>
              </div>

              <div class="form_actions">
                <button type="button" class="button-primary " @click="register">{{ $t('auth.btn.register') }}</button>
              </div>

              <div class="login_box" v-if="!$isAuthenticated">
                <label class="form-check-label text-normal">
                  {{ $t('auth.register.note') }}
                  <router-link to="/login" class="text-orange">
                    {{ $t('auth.btn.login') }}
                  </router-link>
                </label>
              </div>
            </div>
          </div>
        </div>
      </div>
    </div>
    <guest-page-footer></guest-page-footer>
  </div>
</template>
<script>
  import { mapState } from 'vuex';
  import rf from '../../common/requests/RequestFactory';
  import CurrencyInput from '../components/CurrencyInput.vue';
  import GuestPageFooter from '../components/GuestPageFooter.vue';
  import Background from '../components/Dashboard/Background';

  export default {
    components: {
      CurrencyInput,
      GuestPageFooter,
      Background
    },
    data () {
      return {
        whitelist: {
          email: '',
          name: '',
          eth_address: '',
          eth_amount: '',
        },
      };
    },
    computed: {
      ...mapState([
        'supportedLocales',
      ]),
    },
    methods: {
      resetError () {
        this.errors.clear();
      },
      register () {
        this.$validator.validateAll()
          .then(() => {
            if (this.errors.any()) {
              return;
            }
            rf.getRequest('WhitelistRequest').create(this.whitelist)
              .then(res => {
                Object.assign(this.whitelist, {
                  email: '',
                  name: '',
                  eth_address: '',
                  eth_amount: '',
                });

                this.$toasted.show('You register successful!', {
                  theme: 'bubble',
                  position: 'top-right',
                  duration: 2000
                });
              })
              .catch((error) => {
                const errors = error.errors;
                this.errors.clear();
                Object.keys(errors).forEach((key) => {
                  this.errors.add({
                    field: key,
                    msg: errors[key][0]
                  });
                });
              });
          });
      },
    },
  }
</script>

<style lang="scss" scoped>
  .guest_page_form {
    margin-top: -24px !important;
    padding-left: 36px !important;
  }
  .guest_page_form_header .sub_title {
    margin-top: 10px!important;
  }
  .guest_page_form_body {
    margin-top: 17px;
  }
  .form_input {
    width: 100% !important;
  }
  .login_box {
    text-align: center;
    margin-top: 19px;
  }
  .text-orange {
    font-size: 12px;
    margin-left: 8px;
    position: relative;
    left: -4px;
  }
</style>
